<script lang="ts">
import CombinatorProperties from "@/components/JsonFormRenderers/CombinatorProperties.vue";
import {
  type ControlElement,
  createCombinatorRenderInfos,
  createDefaultValue,
  isOneOfControl,
  type JsonFormsRendererRegistryEntry,
  rankWith,
} from "@jsonforms/core";
import {
  DispatchRenderer,
  rendererProps,
  type RendererProps,
  useJsonFormsOneOfControl,
} from "@jsonforms/vue";
import { DisabledIconFocus, useTranslator, useVuetifyControl } from "@jsonforms/vue-vuetify";
import isEmpty from "lodash/isEmpty";
import { computed, defineComponent, onMounted, ref } from "vue";
import {
  VBtn,
  VCard,
  VCardActions,
  VCardText,
  VCardTitle,
  VDialog,
  VHover,
  VSelect,
  VSpacer,
} from "vuetify/components";

const controlRenderer = defineComponent({
  name: "OneOfSelectRenderer",
  components: {
    DispatchRenderer,
    CombinatorProperties,
    VDialog,
    VCard,
    VCardTitle,
    VCardText,
    VCardActions,
    VSpacer,
    VBtn,
    VSelect,
    VHover,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    const input = useJsonFormsOneOfControl(props);
    const control = input.control.value;
    const selectedIndex = ref<number | null>(null);
    const selectIndex = ref<number | null>(null);
    const newSelectedIndex = ref(0);
    const dialog = ref(false);
    const t = useTranslator();

    const indexedOneOfRenderInfos = computed(() => createCombinatorRenderInfos(
      control.schema.oneOf!,
      control.rootSchema,
      "oneOf",
      control.uischema,
      control.path,
      control.uischemas,
    ).filter(info => info.uischema).map((info, index) => ({ ...info, index })));

    const formatNoDefault = computed(() => control.schema.format === "no_default");

    const initializeDefaultValue = () => {
      if (selectedIndex.value === null) return;
      const defaultSchema = indexedOneOfRenderInfos.value[selectedIndex.value]?.schema;
      const defaultValue = createDefaultValue(defaultSchema);
      input.handleChange(control.path, defaultValue);
    };

    onMounted(() => {
      if (!isEmpty(control.data)) {
        selectedIndex.value = control.indexOfFittingSchema ?? 0;
        selectIndex.value = selectedIndex.value;
      } else if (!formatNoDefault.value) {
        selectedIndex.value = 0;
        selectIndex.value = 0;
        initializeDefaultValue();
      }
    });

    return {
      ...useVuetifyControl(input),
      selectedIndex,
      selectIndex,
      dialog,
      newSelectedIndex,
      t,
      indexedOneOfRenderInfos,
      formatNoDefault,
      initializeDefaultValue,
    };
  },
  methods: {
    handleSelectChange(): void {
      if (!this.control.enabled || this.selectIndex === this.selectedIndex) return;

      if (isEmpty(this.control.data) || this.formatNoDefault) {
        this.selectedIndex = this.selectIndex;
        this.initializeDefaultValue();
        return;
      }

      this.dialog = true;
      this.$nextTick(() => {
        this.newSelectedIndex = this.selectIndex;
        this.selectIndex = this.selectedIndex;
      });

      setTimeout(() => {
        ((this.$refs.confirm as any).$el as HTMLElement).focus();
      });
    },
    confirm(): void {
      this.newSelection();
      this.dialog = false;
    },
    cancel(): void {
      this.newSelectedIndex = this.selectedIndex;
      this.dialog = false;
    },
    newSelection(): void {
      const newSchema = this.indexedOneOfRenderInfos[this.newSelectedIndex].schema;
      const defaultValue = createDefaultValue(newSchema);

      this.handleChange(this.path, defaultValue);

      this.selectIndex = this.newSelectedIndex;
      this.selectedIndex = this.newSelectedIndex;
    },
  },
});

export default controlRenderer;

export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(3, isOneOfControl),
};
</script>

<template>
  <div v-if="control.visible">
    <CombinatorProperties
      :schema="control.schema"
      combinator-keyword="oneOf"
      :path="path"
    />

    <v-row justify="start">
      <v-col cols="12" class="text-left pb-0 ma-0">
        <VHover>
          <VSelect
            v-show="indexedOneOfRenderInfos.length > 1"
            :id="`${control.id}-input`"
            v-model="selectIndex"
            v-disabled-icon-focus
            :class="styles.control.input"
            :disabled="!control.enabled"
            :autofocus="appliedOptions.focus"
            :placeholder="appliedOptions.placeholder"
            :label="computedLabel"
            :hint="control.description"
            :persistent-hint="persistentHint()"
            :required="control.required"
            :clearable="true"
            :items="indexedOneOfRenderInfos"
            :item-title="(item) => t(item.label, item.label)"
            item-value="index"
            v-bind="vuetifyProps('v-select')"
            @update:model-value="handleSelectChange"
            @focus="isFocused = true"
            @blur="isFocused = false"
          />
        </VHover>
      </v-col>
      <DispatchRenderer
        v-if="selectedIndex !== undefined && selectedIndex !== null"
        :schema="indexedOneOfRenderInfos[selectedIndex].schema"
        :uischema="indexedOneOfRenderInfos[selectedIndex].uischema"
        :path="control.path"
        :renderers="control.renderers"
        :cells="control.cells"
        :enabled="control.enabled"
      />
    </v-row>

    <VDialog
      v-if="control.data && dialog"
      v-model="dialog"
      persistent
      max-width="600"
      @keydown.esc="cancel"
    >
      <VCard>
        <VCardTitle class="text-h5">
          Clear form ?
        </VCardTitle>
        <VCardText>
          Your data will be cleared if you select this new option. Do you want to proceed?
        </VCardText>
        <VCardActions>
          <VSpacer />
          <VBtn text @click="cancel">
            No
          </VBtn>
          <VBtn
            ref="confirm"
            text
            @click="confirm"
          >
            Yes
          </VBtn>
        </VCardActions>
      </VCard>
    </VDialog>
  </div>
</template>
